package eu.kanade.tachiyomi.util.system

import android.annotation.SuppressLint
import android.os.Build
import logcat.LogPriority
import java.util.Locale

object DeviceUtil {

    fun isMiui() = getSystemProperty("ro.miui.ui.version.name")?.isNotEmpty() ?: false

    @SuppressLint("PrivateApi")
    fun isMiuiOptimizationDisabled(): Boolean {
        val sysProp = getSystemProperty("persist.sys.miui_optimization")
        if (sysProp == "0" || sysProp == "false") {
            return true
        }

        return try {
            Class.forName("android.miui.AppOpsUtils")
                .getDeclaredMethod("isXOptMode")
                .invoke(null) as Boolean
        } catch (e: Exception) {
            false
        }
    }

    fun isSamsung() = Build.MANUFACTURER.lowercase(Locale.ENGLISH) == "samsung"

    @SuppressLint("PrivateApi")
    private fun getSystemProperty(key: String?): String? {
        return try {
            Class.forName("android.os.SystemProperties")
                .getDeclaredMethod("get", String::class.java)
                .invoke(null, key) as String
        } catch (e: Exception) {
            logcat(LogPriority.WARN, e) { "Unable to use SystemProperties.get()" }
            null
        }
    }
}
